"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isLiteralType = exports.isBasicObjectType = exports.isFunctionType = exports.isArrayType = exports.isNumberIndexedType = exports.isStringIndexedObjectType = exports.isRecordType = exports.isTupleType = exports.isVoid = exports.isAnyOrUnknown = exports.isPrimitiveType = exports.isObjectType = void 0;
var ts = __importStar(require("typescript"));
var flags_1 = require("./flags");
function isObjectType(type) {
    return flags_1.extractFlags(type.flags).includes(ts.TypeFlags.Object);
}
exports.isObjectType = isObjectType;
function isPrimitiveType(type) {
    return flags_1.extractFlags(type.flags).some(function (flag) {
        return [
            ts.TypeFlags.String,
            ts.TypeFlags.Number,
            ts.TypeFlags.Boolean,
            ts.TypeFlags.Null,
            ts.TypeFlags.Undefined
        ].includes(flag);
    });
}
exports.isPrimitiveType = isPrimitiveType;
function isAnyOrUnknown(type) {
    return flags_1.extractFlags(type.flags).some(function (f) {
        return [ts.TypeFlags.Any, ts.TypeFlags.Unknown].includes(f);
    });
}
exports.isAnyOrUnknown = isAnyOrUnknown;
function isVoid(type) {
    return flags_1.extractFlags(type.flags).includes(ts.TypeFlags.Void);
}
exports.isVoid = isVoid;
function isTupleType(type) {
    var _a;
    return (typeof ((_a = type.target) === null || _a === void 0 ? void 0 : _a.hasRestElement) === "boolean");
}
exports.isTupleType = isTupleType;
function isRecordType(type) {
    return type.aliasSymbol && type.aliasSymbol.escapedName === "Record";
}
exports.isRecordType = isRecordType;
function isStringIndexedObjectType(type) {
    return type.getStringIndexType();
}
exports.isStringIndexedObjectType = isStringIndexedObjectType;
function isNumberIndexedType(type) {
    return type.getNumberIndexType();
}
exports.isNumberIndexedType = isNumberIndexedType;
function isArrayType(type) {
    return type.symbol.escapedName === "Array";
}
exports.isArrayType = isArrayType;
function isFunctionType(type) {
    return !!type.getCallSignatures().length;
}
exports.isFunctionType = isFunctionType;
function isBasicObjectType(type, checker) {
    return checker.typeToString(type) === "object";
}
exports.isBasicObjectType = isBasicObjectType;
function isLiteralType(type) {
    return flags_1.extractFlags(type.flags).some(function (f) {
        return [
            ts.TypeFlags.StringLiteral,
            ts.TypeFlags.NumberLiteral,
            ts.TypeFlags.BooleanLiteral
        ].includes(f);
    });
}
exports.isLiteralType = isLiteralType;
//# sourceMappingURL=type.js.map